//funkce 1-3,5,10(ALLC,ALLF,DELETE,MAXF,MAXC,MINF,MINC)


//vložení knihoven
#include <EEPROM.h>
#include <TM1636.h>
#include <math.h>
//definice led displaye
TM1636 led(7,8);
int maxtemp = 0;
int mintemp = 0;
void setup() {
  //inicializace seriového portu
  Serial.begin(9600);
  //definování I/O pinů
  pinMode(6, OUTPUT);
  //inicializace displaye
  led.init();
  //načtení maxima a minima
  loadmaxmin();
}

void loop() {
  //kontrola přikazů
  cmd();
  //uložení teploty
  savetemp();
  //prečtení hodnoty z fotorezistoru
  int light = analogRead(A1);
  if(light > 300){ // když zhasnuto
     int ms = 0;
     //čekání
     do {
      //zobrazení teploty
      showtemp();
       //kontrola přikazů
  cmd();
      //počítaní ms po 10;
      ms += 10;
      //prečtení hodnoty z fotorezistoru
      light = analogRead(A1);
      // když napočítáno 30s tak spusť alarm
      if(ms > 30000){
        do { //alarm
          //prečtení hodnoty z fotorezistoru
          light = analogRead(A1);
          //zobrazení teploty
          showtemp();
           //kontrola přikazů
          cmd();
          //bzučení
          digitalWrite(6, HIGH);
          delay(100);
          digitalWrite(6, LOW);
          delay(100);
          } while(light > 300); //když je tma přestaň bzučet
          //vrať se do normalního režimu
          break;
        }
        //počítá se po 10 takže musí 10ms počkat 
        delay(10);
        //když tma tak přestaň počítat                              
      } while(light > 300);
    } else {
      //Zhasni display
      led.clearDisplay();
      }
}

void cmd(){ // funcke na přečtení a vykonání příkazů
  if(Serial.available()){
    //uložení příkazu
    String cmd = Serial.readString();
    //převedení na velká pismena
    cmd.toUpperCase();
    if(cmd == "MAXC"){  //MAXC
      Serial.print(maxtemp);
      Serial.println("C");
      } else if(cmd == "MAXF"){   //MAXf
      Serial.print(round((float)maxtemp /((float)5/(float)9) + (float)32));
      Serial.println("F");
      } else if(cmd == "MINC"){  //MINC
       Serial.print(mintemp);
       Serial.println("C"); 
        } else if(cmd == "MINF"){  //MINF
       Serial.print(round((float)mintemp /((float)5/(float)9) + (float)32));
       Serial.println("F");
        } else if(cmd == "ALLC"){  //ALLC
          Serial.print(mintemp);
          Serial.println("C");
          Serial.print(maxtemp);
          Serial.println("C");
          } else if(cmd == "ALLF"){   //ALLF
          Serial.print(round((float)mintemp /((float)5/(float)9) + (float)32));
          Serial.println("F");
          Serial.print(round((float)maxtemp /((float)5/(float)9) + (float)32));
          Serial.println("F");
          } else if(cmd == "DELETE"){  //DELETE
            //nulování
            maxtemp = 0;
            mintemp = 0;
            //uložení do EEPROM
            savemaxmin();
            Serial.println("OK");
            } else {
              Serial.println("Neplatny prikaz!");
              } 
    }
  }
void showtemp(){
  //vypočti teplotu
  float temp = round(map(analogRead(A0),250,1000,1.4,139.5) / 2);
      //kontrola minimální teploty
      if(temp < mintemp || mintemp == 0){
        mintemp = temp;
        //ulož do EEPROM
        savemaxmin();
        }
        //kontrola maximální teploty
      if(temp > maxtemp){
        maxtemp = temp;
         //ulož do EEPROM
        savemaxmin();
        }
        
      //založ array na data do displaye
      int8_t data[4];
      //1.místo bude prázdné
      data[0] = 10;
      //vypočti disítky
      data[1] = floor(temp / 10);
      temp -= data[1] * 10;
      // vypočti jednotky
      data[2] = temp;
      //nevím kod na C tak jsem tam dal prázdné místo
      data[3] = 10; 
      //zobraz data na display
      led.display(data);
  }
void savetemp(){
  float temp = round(map(analogRead(A0),250,1000,1.4,139.5) / 2);
      //kontrola minimální teploty
      if(temp < mintemp || mintemp == 0){
        mintemp = temp;
        //ulož do EEPROM
        savemaxmin();
        }
        //kontrola maximální teploty
      if(temp > maxtemp){
        maxtemp = temp;
         //ulož do EEPROM
        savemaxmin();
        }
  }
void savemaxmin(){
  //uloženi minima do EEPROM
  EEPROM.put(0,mintemp);
  //uložení maxima do EEPROM
  EEPROM.put(100,maxtemp);
  }

void loadmaxmin(){
  //čtení minima z EEPROM
  EEPROM.get(0,mintemp);
  //čtení maxima z EEPROM
  EEPROM.get(100,maxtemp);
  }
